using System;
using System.Data;
using System.Threading;


namespace HeartbeatDotNET
{
	class Heartbeat
	{
		private const string szLEDName = "LED1:";
		private static byte[] LED_ON = {Convert.ToByte(1)};
		private static byte[] LED_OFF = {Convert.ToByte(0)};

		static void Main(string[] args)
		{
			int		hPort			= CEAPI.INVALID_HANDLE_VALUE;
			int		dwSize          = 0;
			int		c				= 0;
			int		iIterations		= 0;

			if(args.Length == 0)
				Console.WriteLine("Starting Heartbeat - infinite run");
			else
			{
				Console.WriteLine("Starting Heartbeat - {0} iterations", args.GetValue(0));
				iIterations = int.Parse((string)args.GetValue(0));	
			}
			
			if((iIterations == 0) || (iIterations < -1))
				iIterations = -1;
			else
				c = 1;
			
			Thread.Sleep(1000);

			// open LED
			hPort = CEAPI.CreateFile(szLEDName, CEAPI.GENERIC_WRITE, 0, 0, CEAPI.OPEN_EXISTING, 0, 0);

			// check for success
			if(hPort == CEAPI.INVALID_HANDLE_VALUE)
			{
				Console.WriteLine("Failed to open " + szLEDName + ": {0}", CEAPI.GetLastError());
				
				// keep console visible
				Console.ReadLine();

				return;
			}

			// ensure LED is off
			CEAPI.WriteFile(hPort, LED_OFF, 1, ref dwSize, 0);

			while(true)
			{
				// turn on LED
				CEAPI.WriteFile(hPort, LED_ON, 1, ref dwSize, 0);

				// sleep
				Thread.Sleep(150);		

				// turn off LED
				CEAPI.WriteFile(hPort, LED_OFF, 1, ref dwSize, 0);
		
				// sleep 
				Thread.Sleep(100);

				// turn on LED
				CEAPI.WriteFile(hPort, LED_ON, 1, ref dwSize, 0);

				// sleep
				Thread.Sleep(200);		

				// turn off LED
				CEAPI.WriteFile(hPort, LED_OFF, 1, ref dwSize, 0);
		
				// sleep 
				Thread.Sleep(500);

				if(c > 0)
				{
					if(c++ >= iIterations)
						break;
				}
			}

			// close port
			CEAPI.CloseHandle(hPort);

			Console.WriteLine("Heartbeat finished");
			// keep console visible
			Console.ReadLine();
			return;		
		}
	}
}
